/*
 ***************************************************************
 *
 * File: rwrapper.cpp
 *
 * Implementation by: Christian Stratowa
 *
 * Copyright (C) Christian Stratowa 2007-2009
 *
 * A wrapper to MyClass libraries
 *
 ******************************************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>
using namespace std;

#include "rwrapper.h"
#include "MyClassA.h"

   /*______________________________________________________________________________*/
   void TestMultiply(int *n, int *m, int *num)
   {
      MyClassA *classA = new MyClassA();

      printf("n = %d\n", *n);
      printf("m = %d\n", *m);
      int result = classA->TestMultiply(*n, *m);
      *num = result;

      delete classA;
   }//TestMultiply

   /*______________________________________________________________________________*/
   void TestMyClassC(char **myname, int *n)
   {
      printf("myname_0 = %s\n", myname[0]);
      printf("n = %d\n", *n);

      int nn = *n;
      printf("nn = %d\n", nn);
      if (nn > 1)
         printf("myname1 = %s, %s %d\n", myname[1], " and nn = ", nn);

      MyClassA *classA = new MyClassA();

      classA->TestC(myname[0]);

      delete classA;
   }//TestMyClassC

   /*______________________________________________________________________________*/
   void TestMyClassCpp(char **myname, int *n)
   {
      const char *str = "char_string";
      cout << "  str = " << str << endl;
      cout << "  myname[0] = " << myname[0] << endl;

      int nn = *n;
      cout << "  nn = " << nn << endl;
      if (nn > 1)
         cout << "  myname[1] = " << myname[1] << " and nn = " << nn << endl;

      MyClassA *classA = new MyClassA();

      classA->TestCpp(myname[0]);

      delete classA;
   }//TestMyClassCpp

   /*______________________________________________________________________________*/
   void ReadFileC(char **infile)
   {
      printf("Reading file %s using C style.\n", infile[0]);

      MyClassA *classA = new MyClassA();

      classA->ReadFileC(infile[0]);

      delete classA;
   }//ReadFileC

   /*______________________________________________________________________________*/
   void ReadFileCpp(char **infile)
   {
      printf("Reading file %s using C++ style.\n", infile[0]);

      MyClassA *classA = new MyClassA();

      classA->ReadFileCpp(infile[0]);

      delete classA;
   }//ReadFileCCpp

   /*______________________________________________________________________________*/
   void WriteFileC(char **outfile)
   {
      printf("Writing file %s using C style.\n", outfile[0]);

      MyClassA *classA = new MyClassA();

      classA->WriteFileC(outfile[0]);

      delete classA;
   }//WriteFileC

   /*______________________________________________________________________________*/
   void WriteFileCpp(char **outfile)
   {
      printf("Writing file %s using C++ style.\n", outfile[0]);

      MyClassA *classA = new MyClassA();

      classA->WriteFileCpp(outfile[0]);

      delete classA;
   }//WriteFileCpp

   /*______________________________________________________________________________*/
   void ReadInFile(char **infile)
   {
      printf("Reading input file %s using C++ style.\n", infile[0]);

      MyClassA *classA = new MyClassA();

      classA->ReadInFile(infile[0]);

      delete classA;
   }//ReadInFile

   /*______________________________________________________________________________*/
   void WriteOutFile(char **outfile)
   {
      printf("Writing output file %s using C++ style.\n", outfile[0]);

      MyClassA *classA = new MyClassA();

      classA->WriteOutFile(outfile[0]);

      delete classA;
   }//WriteOutFile


